libsigc++: sigc::signal0< T_return, T_accumulator > Class Template Reference

libsigc++ 2.2.10

- Main Page
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions

# sigc::signal0< T_return, T_accumulator > Class Template Reference
Signals

Signal declaration. More...

`#include <sigc++/signal.h>`

Inheritance diagram for sigc::signal0< T_return, T_accumulator >:
[legend]

List of all members.

## Public Types
typedef internal::signal_emit0 < T_return, T_accumulator > | emitter_type
typedef emitter_type::result_type | result_type
typedef slot< T_return > | slot_type
typedef slot_list< slot_type > | slot_list_type
typedef slot_list_type::iterator | iterator
typedef slot_list_type::const_iterator | const_iterator
typedef slot_list_type::reverse_iterator | reverse_iterator
typedef slot_list_type::const_reverse_iterator | const_reverse_iterator
## Public Member Functions
iterator | connect (const slot_type& slot_)
| Add a slot to the list of slots.
result_type | emit () const
| Triggers the emission of the signal.
result_type | emit_reverse () const
| Triggers the emission of the signal in reverse order (see emit()).
result_type | operator() () const
| Triggers the emission of the signal (see emit()).
bound_const_mem_functor0 < result_type, signal0 > | make_slot () const
| Creates a functor that calls emit() on this signal.
slot_list_type | slots ()
| Creates an STL-style interface for the signal's list of slots.
const slot_list_type | slots () const
| Creates an STL-style interface for the signal's list of slots.
| signal0 (const signal0& src)

## Detailed Description

### template<class T_return, class T_accumulator = nil>
class sigc::signal0< T_return, T_accumulator >

Signal declaration.

signal0 can be used to connect() slots that are invoked during subsequent calls to emit(). Any functor or slot can be passed into connect(). It is converted into a slot implicitly.

If you want to connect one signal to another, use make_slot() to retrieve a functor that emits the signal when invoked.

Be careful if you directly pass one signal into the connect() method of another: a shallow copy of the signal is made and the signal's slots are not disconnected until both the signal and its clone are destroyed, which is probably not what you want!

An STL-style list interface for the signal's list of slots can be retrieved with slots(). This interface supports iteration, insertion and removal of slots.

The following template arguments are used:

- T_return The desired return type for the emit() function (may be overridden by the accumulator).
- T_accumulator The accumulator type used for emission. The default `nil` means that no accumulator should be used, for example if signal emission returns the return value of the last slot invoked.

You should use the more convenient unnumbered sigc::signal template.

## Member Function Documentation

template <class T_return, class T_accumulator = nil>

iterator sigc::signal0< T_return, T_accumulator >::connect | ( | const slot_type& | slot_ | ) | `[inline]`

Add a slot to the list of slots.

Any functor or slot may be passed into connect(). It will be converted into a slot implicitely. The returned iterator may be stored for disconnection of the slot at some later point. It stays valid until the slot is removed from the list of slots. The iterator can also be implicitely converted into a sigc::connection object that may be used safely beyond the life time of the slot.

Parameters:

  slot_ | The slot to add to the list of slots.

Returns:
  An iterator pointing to the new slot in the list.

template <class T_return, class T_accumulator = nil>

result_type sigc::signal0< T_return, T_accumulator >::emit | ( |  | ) | const`[inline]`

Triggers the emission of the signal.

During signal emission all slots that have been connected to the signal are invoked unless they are manually set into a blocking state. The parameters are passed on to the slots. If T_accumulated is not `nil`, an accumulator of this type is used to process the return values of the slot invocations. Otherwise, the return value of the last slot invoked is returned.

Returns:
  The accumulated return values of the slot invocations.

template <class T_return, class T_accumulator = nil>

result_type sigc::signal0< T_return, T_accumulator >::emit_reverse | ( |  | ) | const`[inline]`

Triggers the emission of the signal in reverse order (see emit()).

template <class T_return, class T_accumulator = nil>

bound_const_mem_functor0<result_type, signal0> sigc::signal0< T_return, T_accumulator >::make_slot | ( |  | ) | const`[inline]`

Creates a functor that calls emit() on this signal.

     sigc::mem_fun(mysignal, &sigc::signal0::emit)

yields the same result.

Returns:
  A functor that calls emit() on this signal.

template <class T_return, class T_accumulator = nil>

result_type sigc::signal0< T_return, T_accumulator >::operator() | ( |  | ) | const`[inline]`

Triggers the emission of the signal (see emit()).

template <class T_return, class T_accumulator = nil>

slot_list_type sigc::signal0< T_return, T_accumulator >::slots | ( |  | ) | `[inline]`

Creates an STL-style interface for the signal's list of slots.

This interface supports iteration, insertion and removal of slots.

Returns:
  An STL-style interface for the signal's list of slots.

template <class T_return, class T_accumulator = nil>

const slot_list_type sigc::signal0< T_return, T_accumulator >::slots | ( |  | ) | const`[inline]`

Creates an STL-style interface for the signal's list of slots.

This interface supports iteration, insertion and removal of slots.

Returns:
  An STL-style interface for the signal's list of slots.